﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Collections;

using System.Web.Configuration;
using System.Data.OleDb;
using System.Data.SqlClient;

namespace com.WizardWu.DAL
{
    public class DbAccess
    {
        // 取得 Web.config 的第一組連線字串的名稱(OleDb)
        public string strConnString = System.Configuration.ConfigurationManager.ConnectionStrings[GetFirstConnStringName()].ToString();

        // 取得 Web.config 的第二組連線字串的名稱(SqlClient)
        public string strConnString2 = System.Configuration.ConfigurationManager.ConnectionStrings["ConnString_SqlClient_sql2005"].ToString();

        public DbAccess()
        {
        }

        #region ****** 將圖檔上傳至 SQL Server 2005 的 varbinary(MAX) 欄位 ******

        public void UploadImageToDB(string strSql, string strImageName, byte[] byteImageLength)
        {
            SqlConnection sqlConn = null;
            SqlCommand sqlCmd = null;

            try
            {
                sqlConn = new SqlConnection(strConnString2);
                sqlConn.Open();

                if (sqlConn.State == ConnectionState.Open)
                {
                    sqlCmd = new SqlCommand(strSql, sqlConn);
                    sqlCmd.Parameters.Add("@ImageName", SqlDbType.NVarChar).Value = strImageName;
                    sqlCmd.Parameters.Add("@ImageData", SqlDbType.VarBinary, byteImageLength.Length).Value = byteImageLength;
                    sqlCmd.ExecuteNonQuery();
                }
            }
            catch (Exception ex)
            {
                throw new Exception(ex.Message);
            }
            finally
            {
                if (sqlCmd != null)
                    sqlCmd.Dispose();
                if (sqlConn.State == ConnectionState.Open)
                {
                    sqlConn.Close();
                }
                sqlConn.Dispose();
            }
        }

        #endregion ****** 將圖檔上傳至 SQL Server 2005 的 varbinary(MAX) 欄位 ******


        #region ****** 從 SQL Server 2005 的 varbinary(MAX) 欄位讀取圖檔 ******

        public byte[] ReadImageFromDB(string strSql, string strID, out string strImageName)
        {
            byte[] byteImageData = null;
            SqlConnection sqlConn = null;
            SqlCommand sqlCmd = null;
            SqlDataReader sqlReader = null;
            strImageName = string.Empty;

            try
            {
                sqlConn = new  SqlConnection(strConnString2);
                sqlConn.Open();

                if (sqlConn.State == ConnectionState.Open)
                {
                    sqlCmd = new SqlCommand(strSql, sqlConn);
                    sqlCmd.Parameters.Add("@ID", SqlDbType.Int).Value = strID;
                    sqlReader = sqlCmd.ExecuteReader(CommandBehavior.SequentialAccess | CommandBehavior.CloseConnection);

                    while (sqlReader.Read())
                    {
                        strImageName = sqlReader.GetValue(0).ToString();
                        byteImageData = new byte[sqlReader.GetBytes(1, 0, null, 0, Int32.MaxValue)];
                        sqlReader.GetBytes(1, 0, byteImageData, 0, byteImageData.Length);

                        break;  // 若已找到目標圖檔，就不再執行後續的迴圈
                    }
                }
            }
            catch (Exception ex)
            {
                throw new Exception(ex.Message);
            }
            finally
            {
                if (sqlReader != null)
                {
                    if (sqlReader.IsClosed == false)
                        sqlReader.Close();
                    sqlReader.Dispose();
                }
                if (sqlCmd != null)
                    sqlCmd.Dispose();
                if (sqlConn.State == ConnectionState.Open)
                {
                    sqlConn.Close();
                }
                sqlConn.Dispose();
            }

            return byteImageData;
        }

        #endregion 從 SQL Server 2005 的 varbinary(MAX) 欄位讀取圖檔 ******
                


        #region ****** 取得 Web.config 的第一組連線字串的名稱 ******
        public static string GetFirstConnStringName()
        {
            // Get the connectionStrings key,value pairs collection.
            ConnectionStringSettingsCollection connectionStrings = WebConfigurationManager.ConnectionStrings as ConnectionStringSettingsCollection;

            // Get the collection enumerator.
            IEnumerator connectionStringsEnum = connectionStrings.GetEnumerator();

            // Loop through the collection and display the connectionStrings key, value pairs.
            int i = 0;
            string strFirstConnStringName = "";
            //Response.Write("[Display connectionStrings]");
            while (connectionStringsEnum.MoveNext())
            {
                i += 1;
                if (i == 1)
                {
                    // 傳回第一組連線字串的 name
                    strFirstConnStringName = connectionStrings[i].Name;
                    break;
                }
            }
            return strFirstConnStringName;
        }
        #endregion ****** 取得 Web.config 的第一組連線字串的名稱 ******


    } // end of class DbAccess

} // end of namespace com.WizardWu.DAL